#!/bin/bash
if [ -z $TESTRTDIR ]
then
echo please set TESTRTDIR first!
exit 1
fi


JAVA=`java -version > /dev/null 2>&1`
if [ $? != 0 ] 
then
	echo "Java not found"
	echo "Please set JAVA_HOME and PATH variables to a newer java kit"
	exit 1
fi

VER=`java -version 2>&1 | head -n1|awk '{print $NF}'`

if [ `echo $VER | grep "1.4"` ]
then
	echo "Bad java release ! Minimum is java 1.5"
	echo "Please set JAVA_HOME and PATH variables to a newer java kit"
	exit 1
fi

rm -f TestRTAdapter.log



echo $TESTRTDIR/RQMAdapter/TestRTadapter/lib/com.ibm.rqm.adapter.library_2.0.1.v20101004_2103.jar > jars.txt
echo $TESTRTDIR/RQMAdapter/TestRTadapter/lib/com.ibm.rqm.integration.client_3.0.0.v20100823_1947/integration.client.jar >> jars.txt
echo $TESTRTDIR/RQMAdapter/TestRTadapter/lib/com.ibm.rqm.integration.client_3.0.0.v20100823_1947/lib/commons-codec-1.3.jar >> jars.txt
echo $TESTRTDIR/RQMAdapter/TestRTadapter/lib/com.ibm.rqm.integration.client_3.0.0.v20100823_1947/lib/commons-httpclient-3.0.jar >> jars.txt
echo $TESTRTDIR/RQMAdapter/TestRTadapter/lib/com.ibm.rqm.integration.client_3.0.0.v20100823_1947/lib/org.apache.commons.logging_1.0.4.v20080605-1930.jar >> jars.txt
ls  $TESTRTDIR/RQMAdapter/TestRTadapter/lib/*.jar | grep -v com.ibm.rqm.adapter.library_1 | grep -v com.ibm.rqm.adapter.library_2.0.0 | grep -v com.ibm.rqm.integration.client_1 >> jars.txt


CLPATH=""
for line in $(cat jars.txt) 
do
CLPATH=$line:$CLPATH
done

$TESTRTDIR/testrtinit.sh

java -Dlog4j.configuration=file:$TESTRTDIR/RQMAdapter/TestRTadapter/log4j.properties -classpath "$CLPATH" com.ibm.rqm.adapter.testrt.QMTestRTAdapter $*
