package com.ibm.rqm.adapter.commandline;

import java.util.Date;

import com.ibm.rqm.adapter.library.data.AdapterException;
import com.ibm.rqm.adapter.library.data.CustomProperty;
import com.ibm.rqm.adapter.library.data.NewRequester;

public class LogProgress {

	private NewRequester requester = null;
	private String url = null;
	CustomProperty[] properties = null;
	
	protected LogProgress(String url, NewRequester requester) {
		this.url = url;
		this.requester = requester;
		properties = new CustomProperty[3];
		properties[0] = new CustomProperty();
		properties[1] = new CustomProperty();
		properties[2] = new CustomProperty();
		properties[0].setPropertyName("Status");
		properties[1].setPropertyName("Time");
		properties[2].setPropertyName("Resource URN");
	}
	
	protected void LogProgress(int progress, int responseCode) {
		try {
			requester.logProgress(url, progress, responseCode, null);
		} catch (AdapterException ae) {
			Logger.Log.error("Unable to log execution progress", ae);
		}
	}
	
	protected void logProgress(int progress, String status, String urn) {
		try {
			properties[0].setPropertyValue(status);
			properties[1].setPropertyValue((new Date()).toString());
			if ( urn != null )
				properties[2].setPropertyValue(urn);
			requester.logProgress(url, progress, 200, null, null, properties);
		} catch (AdapterException ae) {
			Logger.Log.error("Unable to log execution progress", ae);
		}
	}

}
