#if RTRT_IO==RTRT_STD
isCreated : boolean := false;
#endif

#if RTRT_CLOCK == RTRT_STD
-- STD priv_clock
function priv_clock return priv_int is
subtype c_long_int is priv_int;
type tms is record
                tms_utime : c_long_int;
                tms_stime : c_long_int;
                tms_cutime : c_long_int;
                tms_cstime : c_long_int;
              end record;
tms_rec:tms;
result:priv_int;
procedure  times (X:ADDRESS) ;
pragma interface(C,times);
begin
    -- must return -1 if clock is not implemented
    result:=-1; 
    times(tms_rec'address);
    result := priv_int(tms_rec.tms_utime);
    return(result);
end priv_clock;
#endif /* RTRT_CLOCK */

#if RTRT_CLOCK == RTRT_NONE
-- NONE priv_clock
function priv_clock return priv_int is
result:priv_int;
begin
    -- must return -1 if clock is not implemented
    result:=-1; 
    return(result);
end priv_clock;
#endif /* RTRT_CLOCK */



#if RTRT_IO==RTRT_STD
-- STD IO
procedure priv_init(I : in integer) is
begin
                null;
end priv_init;
procedure priv_open(file : in out priv_file; name : in string ) is
begin
	if ( not isCreated ) then
		text_io.create(file,text_io.out_file,name);
		isCreated := true;
	else
		text_io.open(file,text_io.append_file,name);
	end if;

end priv_open;
procedure priv_writeln(file : in out priv_file; line: in string) is
begin
	text_io.put(file,line);
	text_io.new_line(file);
end priv_writeln;
procedure priv_close(file : in out priv_file) is
begin
	text_io.close(file);
end priv_close;
#endif /* RTRT_IO */

#if RTRT_IO==RTRT_NONE
-- NONE IO
procedure priv_init(I : in integer) is
begin
                null;
end priv_init;
procedure priv_open(file : in out priv_file; name : in string ) is
begin
                null;
end priv_open;
procedure priv_writeln(file : in out priv_file; line: in string) is
begin
                null;
end priv_writeln;
procedure priv_close(file : in out priv_file) is
begin
                null;
end priv_close;
#endif /* RTRT_IO */

